/* Robots06
 * Adaptation of gnobots2 game
 * 
 * Written by Dylan Nelson
 *  
 */


using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Data;

namespace Robots06
{
	public class globalConstants
	{
		public const int GAME_ROWS                          = 40;
		public const int GAME_COLS                          = 40;
		public const int INITIAL_SLOW_ENEMIES               = 8;
		public const int INITIAL_FAST_ENEMIES               = 2;
		public const int ADDITIONAL_SLOW_ENEMIES_PER_LEVEL  = 8;
		public const int ADDITIONAL_FAST_ENEMIES_PER_LEVEL  = 2;
		public const int INITIAL_SAFE_TELEPORTS             = 2;
		public const int SAFE_TELEPORTS_PER_WAIT_KILL       = 1;
		public const int PTS_PER_SLOW_ENEMY_KILL            = 10;
		public const int PTS_PER_FAST_ENEMY_KILL            = 20;
	}

	public class unitType
	{
		public const int EMPTY_SPOT = 0;
		public const int PLAYER     = 1;
		public const int SLOW_ENEMY = 2;
		public const int FAST_ENEMY = 4;
		public const int DEBRIS     = 8;
	}

	public class unitClass
	{
		public int unitType;
		public int X;
		public int Y;

		//constructor
		public unitClass(int inpUnitType, int inpX, int inpY)
		{
			unitType = inpUnitType;
			X = inpX;
			Y = inpY;
		}

	}

	public enum moveDirection
	{
		MOVE_DOWN,
		MOVE_UP,
		MOVE_LEFT,
		MOVE_RIGHT,
		MOVE_UP_RIGHT,
		MOVE_UP_LEFT,
		MOVE_DOWN_RIGHT,
		MOVE_DOWN_LEFT,
		MOVE_STAY,
		TELEPORT,
		TELEPORT_SAFE,
		WAIT
	}

	/// <summary>
	/// Summary description for Form1.
	/// </summary>
	public class MainForm : System.Windows.Forms.Form
	{
//		private int[,] curGameState;
//		private int[,] nextGameState;

		private unitClass[] curGameState;
//		int curPlayerX, curPlayerY;
		int numSlowEnemies, numFastEnemies, unitArraySize, curPlayerLevel,
			numAliveRobots, numSafeTeleports;
		long curPlayerScore;
		bool gameRunning;
		debugWindow myDebugWindow = new debugWindow();

		private System.Windows.Forms.MainMenu mainMenu1;
		private System.Windows.Forms.MenuItem File_menu;
		private System.Windows.Forms.MenuItem File_newgame;
		private System.Windows.Forms.MenuItem File_quit;
		private System.Windows.Forms.MenuItem Edit_menu;
		private System.Windows.Forms.MenuItem Help_menu;
		private System.Windows.Forms.MenuItem Help_about;
		private System.Windows.Forms.MenuItem Edit_prefs;
		private System.Windows.Forms.MenuItem Debug_menu;
		private System.Windows.Forms.MenuItem Debug_lvl1;
		private System.Windows.Forms.MenuItem Debug_lvl2;
		private System.Windows.Forms.MenuItem Debug_lvl3;
		private System.Windows.Forms.MenuItem Debug_lvl4;
		private System.Windows.Forms.MenuItem Debug_lvl5;
		private System.Windows.Forms.MenuItem Debug_lvl6;
		private System.Windows.Forms.StatusBar myStatusBar;
		private System.Windows.Forms.MenuItem menuItem1;
		/// <summary>
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;

		public MainForm()
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();

			//
			// TODO: Add any constructor code after InitializeComponent call
			//
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if (components != null) 
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			this.mainMenu1 = new System.Windows.Forms.MainMenu();
			this.File_menu = new System.Windows.Forms.MenuItem();
			this.File_newgame = new System.Windows.Forms.MenuItem();
			this.File_quit = new System.Windows.Forms.MenuItem();
			this.Edit_menu = new System.Windows.Forms.MenuItem();
			this.Edit_prefs = new System.Windows.Forms.MenuItem();
			this.menuItem1 = new System.Windows.Forms.MenuItem();
			this.Help_menu = new System.Windows.Forms.MenuItem();
			this.Help_about = new System.Windows.Forms.MenuItem();
			this.Debug_menu = new System.Windows.Forms.MenuItem();
			this.Debug_lvl1 = new System.Windows.Forms.MenuItem();
			this.Debug_lvl2 = new System.Windows.Forms.MenuItem();
			this.Debug_lvl3 = new System.Windows.Forms.MenuItem();
			this.Debug_lvl4 = new System.Windows.Forms.MenuItem();
			this.Debug_lvl5 = new System.Windows.Forms.MenuItem();
			this.Debug_lvl6 = new System.Windows.Forms.MenuItem();
			this.myStatusBar = new System.Windows.Forms.StatusBar();
			this.SuspendLayout();
			// 
			// mainMenu1
			// 
			this.mainMenu1.MenuItems.AddRange(new System.Windows.Forms.MenuItem[] {
																					  this.File_menu,
																					  this.Edit_menu,
																					  this.Help_menu,
																					  this.Debug_menu});
			// 
			// File_menu
			// 
			this.File_menu.Index = 0;
			this.File_menu.MenuItems.AddRange(new System.Windows.Forms.MenuItem[] {
																					  this.File_newgame,
																					  this.File_quit});
			this.File_menu.Text = "File";
			// 
			// File_newgame
			// 
			this.File_newgame.Index = 0;
			this.File_newgame.Text = "New Game";
			this.File_newgame.Click += new System.EventHandler(this.File_newgame_Click);
			// 
			// File_quit
			// 
			this.File_quit.Index = 1;
			this.File_quit.Text = "Quit";
			this.File_quit.Click += new System.EventHandler(this.File_quit_Click);
			// 
			// Edit_menu
			// 
			this.Edit_menu.Index = 1;
			this.Edit_menu.MenuItems.AddRange(new System.Windows.Forms.MenuItem[] {
																					  this.Edit_prefs,
																					  this.menuItem1});
			this.Edit_menu.Text = "Edit";
			// 
			// Edit_prefs
			// 
			this.Edit_prefs.Index = 0;
			this.Edit_prefs.Text = "Controls";
			this.Edit_prefs.Click += new System.EventHandler(this.Edit_prefs_Click);
			// 
			// menuItem1
			// 
			this.menuItem1.Index = 1;
			this.menuItem1.Text = "Preferences";
			this.menuItem1.Click += new System.EventHandler(this.menuItem1_Click);
			// 
			// Help_menu
			// 
			this.Help_menu.Index = 2;
			this.Help_menu.MenuItems.AddRange(new System.Windows.Forms.MenuItem[] {
																					  this.Help_about});
			this.Help_menu.Text = "Help";
			// 
			// Help_about
			// 
			this.Help_about.Index = 0;
			this.Help_about.Text = "About";
			this.Help_about.Click += new System.EventHandler(this.Help_about_Click);
			// 
			// Debug_menu
			// 
			this.Debug_menu.Index = 3;
			this.Debug_menu.MenuItems.AddRange(new System.Windows.Forms.MenuItem[] {
																					   this.Debug_lvl1,
																					   this.Debug_lvl2,
																					   this.Debug_lvl3,
																					   this.Debug_lvl4,
																					   this.Debug_lvl5,
																					   this.Debug_lvl6});
			this.Debug_menu.Text = "Debug";
			// 
			// Debug_lvl1
			// 
			this.Debug_lvl1.Index = 0;
			this.Debug_lvl1.Text = "Load Level 1";
			this.Debug_lvl1.Click += new System.EventHandler(this.Debug_lvl1_Click);
			// 
			// Debug_lvl2
			// 
			this.Debug_lvl2.Index = 1;
			this.Debug_lvl2.Text = "Load Level 2";
			this.Debug_lvl2.Click += new System.EventHandler(this.Debug_lvl2_Click);
			// 
			// Debug_lvl3
			// 
			this.Debug_lvl3.Index = 2;
			this.Debug_lvl3.Text = "Load Level 3";
			this.Debug_lvl3.Click += new System.EventHandler(this.Debug_lvl3_Click);
			// 
			// Debug_lvl4
			// 
			this.Debug_lvl4.Index = 3;
			this.Debug_lvl4.Text = "Load Level 4";
			this.Debug_lvl4.Click += new System.EventHandler(this.Debug_lvl4_Click);
			// 
			// Debug_lvl5
			// 
			this.Debug_lvl5.Index = 4;
			this.Debug_lvl5.Text = "Load Level 5";
			this.Debug_lvl5.Click += new System.EventHandler(this.Debug_lvl5_Click);
			// 
			// Debug_lvl6
			// 
			this.Debug_lvl6.Index = 5;
			this.Debug_lvl6.Text = "Load level 6";
			this.Debug_lvl6.Click += new System.EventHandler(this.Debug_lvl6_Click);
			// 
			// myStatusBar
			// 
			this.myStatusBar.Location = new System.Drawing.Point(0, 694);
			this.myStatusBar.Name = "myStatusBar";
			this.myStatusBar.Size = new System.Drawing.Size(672, 24);
			this.myStatusBar.TabIndex = 1;
			this.myStatusBar.Text = "Welcome to Robots06.";
			// 
			// MainForm
			// 
			this.AutoScale = false;
			this.AutoScaleBaseSize = new System.Drawing.Size(6, 15);
			this.BackColor = System.Drawing.Color.Gray;
			this.ClientSize = new System.Drawing.Size(672, 718);
			this.Controls.AddRange(new System.Windows.Forms.Control[] {
																		  this.myStatusBar});
			this.FormBorderStyle = System.Windows.Forms.FormBorderStyle.Fixed3D;
			this.MaximizeBox = false;
			this.MaximumSize = new System.Drawing.Size(682, 760);
			this.Menu = this.mainMenu1;
			this.MinimumSize = new System.Drawing.Size(682, 760);
			this.Name = "MainForm";
			this.SizeGripStyle = System.Windows.Forms.SizeGripStyle.Hide;
			this.StartPosition = System.Windows.Forms.FormStartPosition.WindowsDefaultBounds;
			this.Text = "Robots06";
			this.Load += new System.EventHandler(this.MainForm_Load);
			this.MouseUp += new System.Windows.Forms.MouseEventHandler(this.MouseUp_Handle);
			this.KeyUp += new System.Windows.Forms.KeyEventHandler(this.KeyPress_Handle);
			this.Paint += new System.Windows.Forms.PaintEventHandler(this.onPaintPaint);
			this.ResumeLayout(false);

		}
		#endregion

		/// <summary>
		/// The main entry point for the application.
		/// </summary>
		[STAThread]
		static void Main() 
		{
			Application.Run(new MainForm());
		}


		private void MainForm_Load(object sender, System.EventArgs e)
		{
			//-----------------
			//startup code here
			//----------------
			myDebugWindow.Show();
			myDebugWindow.SetDesktopLocation(this.DesktopLocation.X + this.Width + 20, this.DesktopLocation.Y);

			debugMsg("Robots06 Startup.");

			//gameState curState = new gameState();
//			curGameState = new int[globalConstants.GAME_COLS, globalConstants.GAME_ROWS];
//			nextGameState = new int[globalConstants.GAME_COLS, globalConstants.GAME_ROWS];
//			int numSlowEnemies = globalConstants.INITIAL_SLOW_ENEMIES + (curPlayerLevel-1) * globalConstants.ADDITIONAL_SLOW_ENEMIES_PER_LEVEL;
//			int numFastEnemies = globalConstants.INITIAL_FAST_ENEMIES + (curPlayerLevel-1) * globalConstants.ADDITIONAL_FAST_ENEMIES_PER_LEVEL;
			
			//unitClass myUnitClass = new unitClass();
			//curGameState = new myUnitClass[11];

			//unitClass[] curGameState = new unitClass[11];
			
			//curGameState.Initialize();
//			zeroCurGameState(curGameState);
//			zeroCurGameState(nextGameState);

			gameRunning = false;

			//debugMsg(curGameState[0,0].ToString());

			//drawGameState(curGameState);
		}

		private void drawGameState(unitClass[] curState, Graphics dc)
		{
			debugMsg("drawGameState called.");

			int i, j;
			int center_x, center_y;

			//wipe current display
			System.Drawing.SolidBrush myBackgroundBrush = new System.Drawing.SolidBrush(System.Drawing.Color.Gray);
			dc.FillRectangle(myBackgroundBrush, new Rectangle(0,0,820,820));
			myBackgroundBrush.Dispose();

			//init color brushes
			System.Drawing.SolidBrush myEmptyBrush = new System.Drawing.SolidBrush(System.Drawing.Color.Black);
			System.Drawing.SolidBrush myPlayerBrush = new System.Drawing.SolidBrush(System.Drawing.Color.Green);
			System.Drawing.SolidBrush mySlowEnemyBrush = new System.Drawing.SolidBrush(System.Drawing.Color.Blue);
			System.Drawing.SolidBrush myFastEnemyBrush = new System.Drawing.SolidBrush(System.Drawing.Color.Red);
			System.Drawing.SolidBrush myDebrisBrush = new System.Drawing.SolidBrush(System.Drawing.Color.Yellow);

			//dc.FillRectangle(myBrush, new Rectangle(100,100,120,120));

			//draw empty grid
			for (i=0; i < globalConstants.GAME_ROWS; i++)
			{
				for (j=0; j < globalConstants.GAME_COLS; j++)
				{
					center_x = 20 + 16*i;
					center_y = 20 + 16*j;

					dc.FillRectangle(myEmptyBrush, new Rectangle(center_x-1,center_y-1,2,2));

					//debugMsg(curGameState[i,j].ToString());
				}
			}
			
			//populate (overdraw) empty grid with units
			for (i=0; i < curState.GetLength(0); i++)
			{
				center_x = 20 + 16 * curState[i].X;
				center_y = 20 + 16 * curState[i].Y;

				//if (curState[i].unitType == unitType.EMPTY_SPOT)
				//	dc.FillRectangle(myEmptyBrush, new Rectangle(center_x-1,center_y-1,2,2));

				if (curState[i].unitType == unitType.PLAYER)
					dc.FillRectangle(myPlayerBrush, new Rectangle(center_x-5,center_y-5,10,10));

				if (curState[i].unitType == unitType.SLOW_ENEMY)
					dc.FillRectangle(mySlowEnemyBrush, new Rectangle(center_x-5,center_y-5,10,10));

				if (curState[i].unitType == unitType.FAST_ENEMY)
					dc.FillRectangle(myFastEnemyBrush, new Rectangle(center_x-5,center_y-5,10,10));

				if (curState[i].unitType == unitType.DEBRIS)
					//dc.FillRectangle(myDebrisBrush, new Rectangle(center_x-3,center_y-3,6,6));
					dc.FillEllipse(myDebrisBrush, new Rectangle(center_x-5,center_y-5,10,10));
			}

			//cleanup memory
			myPlayerBrush.Dispose();
			mySlowEnemyBrush.Dispose();
			myFastEnemyBrush.Dispose();
			myEmptyBrush.Dispose();
			myDebrisBrush.Dispose();
		}

		//drawPlayerDeath
		private void drawPlayerDeath(Graphics dc)
		{
			Pen myPen = new Pen(Color.White, 2);
			int center_x = 20 + 16 * curGameState[0].X;
			int center_y = 20 + 16 * curGameState[0].Y;

			dc.DrawLine(myPen, center_x-6, center_y-6, center_x+6, center_y+6);
			dc.DrawLine(myPen, center_x-6, center_y+6, center_x+6, center_y-6);
			//dc.DrawString

			this.myStatusBar.Text = "You have died!";
		}

		//drawLevelWon
		private void drawLevelWon(Graphics dc)
		{
			//Pen myPen = new Pen(Color.White, 2);
			//int center_x = 20 + 16 * curGameState[0].X;
			//int center_y = 20 + 16 * curGameState[0].Y;

			//dc.DrawLine(myPen, center_x-2, center_y-2, center_x+2, center_y+2);

			myStatusBar.Text = "Level completed successfully! Advancing to level " + curPlayerLevel.ToString();
		}

		//print outMsg to whatever debug output is setup
		private void debugMsg(string outMsg)
		{
			myDebugWindow.debugTextBox.Text = outMsg + Environment.NewLine + myDebugWindow.debugTextBox.Text;
			//myDebugWindow.debugTextBox.Text += Environment.NewLine;
		}
/*
		//zeroCurGameState
		private void zeroCurGameState(int[,] state)
		{
			debugMsg("zeroCurGameState called");

			int i, j;

			for (i=0; i < globalConstants.GAME_COLS; i++)
			{
				for (j=0; j < globalConstants.GAME_ROWS; j++)
				{
					state[i,j] = 0;
				}
			}
		}
*/
		//randomly generate new starting board for a given level
		private void genStartingBoard(int level)
		{
			numSlowEnemies = globalConstants.INITIAL_SLOW_ENEMIES + (level-1) * globalConstants.ADDITIONAL_SLOW_ENEMIES_PER_LEVEL;
			numFastEnemies = globalConstants.INITIAL_FAST_ENEMIES + (level-1) * globalConstants.ADDITIONAL_FAST_ENEMIES_PER_LEVEL;
			unitArraySize = numSlowEnemies + numFastEnemies + 1; //+1 for player
			numAliveRobots = numSlowEnemies + numFastEnemies;
			int rnd_x, rnd_y, i;

			debugMsg("genStartingBoard called, level " + level.ToString() + " with unitarraysize " + unitArraySize.ToString());

			//generate unit array
			curGameState = new unitClass[unitArraySize];

			//blank instantiation of all units
	//		for (i=0; i < unitArraySize; i++)
	//			curGameState[i] = new unitClass(0,0,0);

			//init random number generator
			Random randomgen = new Random();

			//zero current game state
			//curGameState.Initialize();
//			zeroCurGameState(curGameState);

			//generate slow enemies
			for (i=1; i < numSlowEnemies+1; i++) //start at 1 to avoid 0 player entry
			{
				debugMsg("generating slow enemy using index " + i.ToString());
				rnd_x = randomgen.Next(0, globalConstants.GAME_COLS);
				rnd_y = randomgen.Next(0, globalConstants.GAME_ROWS);
			
				//debugMsg(rnd_x.ToString() + " " + rnd_y.ToString());

				curGameState[i] = new unitClass(unitType.SLOW_ENEMY, rnd_x, rnd_y);
				//curGameState[i].unitType = unitType.SLOW_ENEMY;
				//curGameState[i].X = rnd_x;
				//curGameState[i].Y = rnd_y;
			}

			//generate fast enemies
			for (i=numSlowEnemies+1; i < (numSlowEnemies+numFastEnemies+1); i++) //start after slow enemies
			{
				debugMsg("generating fast enemy using index " + i.ToString());
				rnd_x = randomgen.Next(0, globalConstants.GAME_COLS);
				rnd_y = randomgen.Next(0, globalConstants.GAME_ROWS);
			
				//debugMsg(rnd_x.ToString() + " " + rnd_y.ToString());

				curGameState[i] = new unitClass(unitType.FAST_ENEMY, rnd_x, rnd_y);
				//curGameState[i].unitType = unitType.FAST_ENEMY;
				//curGameState[i].X = rnd_x;
				//curGameState[i].Y = rnd_y;
			}

			//place player at center, array position 0
			curGameState[0] = new unitClass(unitType.PLAYER, globalConstants.GAME_COLS/2, globalConstants.GAME_ROWS/2);
			//curGameState[0].unitType = unitType.PLAYER;
			//curGameState[0].X = globalConstants.GAME_COLS/2;
			//curGameState[0].Y = globalConstants.GAME_ROWS/2;
//			curPlayerX = globalConstants.GAME_COLS/2;
//			curPlayerY = globalConstants.GAME_ROWS/2;
			
		}

		//one full turn logic
		private void takeTurn(moveDirection moveDir)
		{
			debugMsg("takeTurn called movedir " + moveDir.ToString());
			int curStateRet, movePlayerRet;

			System.Drawing.Graphics dc = this.CreateGraphics();

			movePlayerRet = movePlayer(moveDir);

			if(movePlayerRet == 1) //player moved normally ok
			{
				//moveRobots
				moveRobots(false);

				//reprocess curGameState board
				curStateRet = processCurGameState();

				if(curStateRet == 0) //player has died, game over
				{
					debugMsg("takeTurn: curStateRet is 0, player has died");

					gameRunning = false;

					//draw final game state
					drawGameState(curGameState, dc);

					//indicate player death
					drawPlayerDeath(dc);
				}

				//second round for fast robots
				moveRobots(true);
				curStateRet = processCurGameState();

				if(curStateRet == 0) //player has died, game over
				{
					debugMsg("takeTurn: curStateRet is 0, player has died");

					gameRunning = false;

					//draw final game state
					drawGameState(curGameState, dc);

					//indicate player death
					drawPlayerDeath(dc);
				}
				else if(curStateRet == 1) //player still alive, robots still exist
				{
					debugMsg("takeTurn: curStateRet is 1, player still alive, continue play");

					//draw new game state
					drawGameState(curGameState, dc);

					//and done, await new user input
				}
				else if (curStateRet == 2) //player has completed level successfully
				{
					debugMsg("takeTurn: curStateRet is 2, player has completed level successfully");

					curPlayerLevel ++;

					//indicate level won
					drawLevelWon(dc);

					//generate next level
					genStartingBoard(curPlayerLevel);

					//call initial drawGameState
					drawGameState(curGameState, dc);
				}
			}
			else if (movePlayerRet == 2) //player requested wait
			{
				//do wait loop
			}
			else //player tried invalid move (off board)
			{
				//do nothing
			}

			//update statusbar
			updateStatusbar();

			dc.Dispose();

		}

		//movePlayer(moveDirection): attempt to move player in requested direction
		private int movePlayer(moveDirection moveDir)
		{
			debugMsg("movePlayer called movedir " + moveDir.ToString());

			int deltaX, deltaY, i;
			int rnd_x = curGameState[0].X;
			int rnd_y = curGameState[0].Y;

			Random randomgen = new Random();

			if(moveDir == moveDirection.TELEPORT)
			{
				//teleport
				rnd_x = randomgen.Next(0, globalConstants.GAME_COLS);
				rnd_y = randomgen.Next(0, globalConstants.GAME_ROWS);

				curGameState[0].X = rnd_x;
				curGameState[0].Y = rnd_y;

				return 1;
			}
			else if(moveDir == moveDirection.TELEPORT_SAFE)
			{
				//safe teleport
				if (numSafeTeleports > 0)
				{
					bool safe = true;
					bool foundSafe = false;
					while (!foundSafe)
					{
						rnd_x = randomgen.Next(0, globalConstants.GAME_COLS);
						rnd_y = randomgen.Next(0, globalConstants.GAME_ROWS);

						for (i=1; i < unitArraySize; i++)
						{
							if (curGameState[i].X == rnd_x && curGameState[i].Y == rnd_y)
								safe = false;
						}

						if(safe)
							foundSafe = true;
					}

					curGameState[0].X = rnd_x;
					curGameState[0].Y = rnd_y;

					numSafeTeleports --;

					return 1;
				}
				else //insufficient num of safe teleports to do teleport
				{
					return 3;
				}
			}
			else if(moveDir == moveDirection.WAIT)
			{
				//wait
				//let takeTurn handle wait loop

				return 2;
			}
			else //normal move
			{
				//calculate deltaX,deltaY based on movement direction
				switch(moveDir)
				{
					case moveDirection.MOVE_LEFT:
						deltaX = -1; deltaY = 0; break;
					case moveDirection.MOVE_RIGHT:
						deltaX = 1; deltaY = 0; break;
					case moveDirection.MOVE_DOWN:
						deltaX = 0; deltaY = 1; break; //note y-axis backwards from traditional
					case moveDirection.MOVE_UP:
						deltaX = 0; deltaY = -1; break; //note y-axis backwards from traditional
					case moveDirection.MOVE_UP_LEFT:
						deltaX = -1; deltaY = -1; break;
					case moveDirection.MOVE_UP_RIGHT:
						deltaX = 1; deltaY = -1; break;
					case moveDirection.MOVE_DOWN_LEFT:
						deltaX = -1; deltaY = 1; break; //note y-axis backwards from traditional
					case moveDirection.MOVE_DOWN_RIGHT:
						deltaX = 1; deltaY = 1; break; //note y-axis backwards from traditional
					case moveDirection.MOVE_STAY:
						deltaX = 0; deltaY = 0; break;
					default:
						deltaX = 0; deltaY = 0; break;
				}

				//check to see player would still be in bounds
				if((curGameState[0].X + deltaX) >= 0 && (curGameState[0].X + deltaX) < globalConstants.GAME_COLS
					&& (curGameState[0].Y + deltaY) >= 0 && (curGameState[0].Y + deltaY) < globalConstants.GAME_ROWS)
				{
					//update curPlayerX, curPlayerY, and update curGameState
					//				curGameState[curPlayerX, curPlayerY] -= unitType.PLAYER;
					//				curPlayerX = curPlayerX + deltaX;
					//				curPlayerY = curPlayerY + deltaY;
					//				curGameState[curPlayerX, curPlayerY] += unitType.PLAYER;
					curGameState[0].X = curGameState[0].X + deltaX;
					curGameState[0].Y = curGameState[0].Y + deltaY;

					return 1;
				}
				else
					return 0;
			} //normal move
		}

		//moveRobots: move all alive robots towards player after a player move
		private void moveRobots(bool fastOnly)
		{
			debugMsg("moveRobots called fastOnly " + fastOnly.ToString());

			int i;
			int deltaX = 0;
			int deltaY = 0;

			//zeroCurGameState(nextGameState);

			for (i=1; i < (numSlowEnemies + numFastEnemies + 1); i++)
			{
				//move robots, ignore any other units
				if( (!fastOnly && (curGameState[i].unitType == unitType.SLOW_ENEMY || curGameState[i].unitType == unitType.FAST_ENEMY) ) ||
					(fastOnly && (curGameState[i].unitType == unitType.FAST_ENEMY) ) )
				{
					debugMsg("moveRobots: moving robot type " + curGameState[i].unitType + " at x " + curGameState[i].X + " y " + curGameState[i].Y
						+ " vs curplayer x " + curGameState[0].X + " y " + curGameState[0].Y);

					//take into account different movement rates
				/*
					offset = 1; //SLOW_ENEMY

					if(curGameState[i].unitType == unitType.FAST_ENEMY)
						offset = 2;
				
					if(curGameState[i].unitType == unitType.FAST_ENEMY)
						mvLoops = 2;
				*/
					//calculate ALLOWED changes in position
					if(curGameState[i].X > curGameState[0].X) //move robot left
						deltaX = -1;
					else if(curGameState[i].X < curGameState[0].X) //move robot right
						deltaX = 1;
					else if(curGameState[i].X == curGameState[0].X) //no x movement
						deltaX = 0;

					if(curGameState[i].Y > curGameState[0].Y) //move robot up
						deltaY = -1;
					else if(curGameState[i].Y < curGameState[0].Y) //move robot down
						deltaY = 1;
					else if(curGameState[i].Y == curGameState[0].Y) //no y movement
						deltaY = 0;

					//move robot
					if(Math.Abs(curGameState[0].X - curGameState[i].X) <= Math.Abs(deltaX))
						curGameState[i].X = curGameState[0].X;
					else
						curGameState[i].X = curGameState[i].X + deltaX;

					if(Math.Abs(curGameState[0].Y - curGameState[i].Y) <= Math.Abs(deltaY))
						curGameState[i].Y = curGameState[0].Y;
					else
						curGameState[i].Y = curGameState[i].Y + deltaY;
				/*	
					for (i=0; i < mvLoops; i++)
					{
						curGameState[i].X = curGameState[i].X + deltaX;
						curGameState[i].Y = curGameState[i].Y + deltaY;
					}
				*/
					//if(curGameState[0].X != curGameState[i].X)
					//	curGameState[i].X = curGameState[i].X + deltaX;
					//if(curGameState[0].Y != curGameState[i].Y)
					//	curGameState[i].Y = curGameState[i].Y + deltaY;

					debugMsg("moveRobots: allowed deltaX " + deltaX.ToString() + " deltaY " + deltaY.ToString() + " moved to X " + 
						curGameState[i].X.ToString() + " Y " + curGameState[i].Y.ToString());
				}
			}
		}

		//processCurGameState: check for collisions & do scoring after a robot move sequence
		private int processCurGameState()
		{
			debugMsg("processCurGameState called, curNumAliveRobots " + numAliveRobots.ToString());

			int i, j;

			//check for player death
			for (i=1; i < unitArraySize; i++) //start at 1 to avoid player
			{
				if (curGameState[i].unitType == unitType.FAST_ENEMY || curGameState[i].unitType == unitType.SLOW_ENEMY)
				{
					if (curGameState[0].X == curGameState[i].X && curGameState[0].Y == curGameState[i].Y)
						return 0;
				}
			}

			//check for robot collisions
			//depending on unit types process accordingly
			for (i=1; i < unitArraySize; i++) //start at 1 to avoid player
			{
				if(curGameState[i].unitType == unitType.SLOW_ENEMY || curGameState[i].unitType == unitType.FAST_ENEMY)
				{
					for (j=1; j < unitArraySize; j++) //start at 1 to avoid player
					{
						if(i != j)
						{
							if(curGameState[i].X == curGameState[j].X && curGameState[i].Y == curGameState[j].Y)
							{
								//simplified
								//if i-th is enemy, and j-th is enemy or debris, turn i-th into debris
							//this is a given at this point
							//	if(curGameState[j].unitType == unitType.DEBRIS || curGameState[j].unitType == unitType.FAST_ENEMY || 
							//		curGameState[j].unitType == unitType.SLOW_ENEMY)
							//	{

								if(curGameState[i].unitType == unitType.SLOW_ENEMY)
									curPlayerScore += globalConstants.PTS_PER_SLOW_ENEMY_KILL;
								if(curGameState[i].unitType == unitType.FAST_ENEMY)
									curPlayerScore += globalConstants.PTS_PER_FAST_ENEMY_KILL;

								curGameState[i].unitType = unitType.DEBRIS;
								numAliveRobots --;

								break;

							//	}

							}
						} //i != j
					} //j
				}
			} //i

			debugMsg("moveRobots: final number of alive robots " + numAliveRobots.ToString());

			if(numAliveRobots > 0)
				return 1; //continue playing level
			else
				return 2; //move on to next level
		}

		//update the statusbar with the current information
		private void updateStatusbar()
		{
			myStatusBar.Text = "Level " + curPlayerLevel.ToString() + "         Safe Teleports Left: " + numSafeTeleports.ToString() + 
				"         Score: " + curPlayerScore.ToString();
		}

		//File->Quit
		private void File_quit_Click(object sender, System.EventArgs e)
		{
			debugMsg("file.quit clicked");

			//cleanup code here
			System.Environment.Exit(0);
		}

		//File->New Game
		private void File_newgame_Click(object sender, System.EventArgs e)
		{
			debugMsg("file.newgame clicked");

			//init new game
			gameRunning = true;
			curPlayerLevel = 1;
			curPlayerScore = 0;
			numSafeTeleports = globalConstants.INITIAL_SAFE_TELEPORTS;

			//generate new starting game board
			genStartingBoard(curPlayerLevel);

			//update statusbar
			updateStatusbar();

			//call initial drawGameState
			System.Drawing.Graphics dc = this.CreateGraphics();
			drawGameState(curGameState, dc);
			dc.Dispose();

			//await user input
		}

		private void onPaintPaint(object sender, System.Windows.Forms.PaintEventArgs e)
		{
			Graphics dc = e.Graphics;

			if(gameRunning)
				drawGameState(curGameState, dc);

			//base.OnPaint(e);

			dc.Dispose();
		}

		//Help->About
		private void Help_about_Click(object sender, System.EventArgs e)
		{
			debugMsg("help.about clicked");

			MessageBox.Show("Robots06" + Environment.NewLine + "Written by Dylan Nelson", "About", MessageBoxButtons.OK, MessageBoxIcon.Information);
		}

		private void Debug_lvl1_Click(object sender, System.EventArgs e)
		{
			debugMsg("debug.loadlevel1 clicked");
			gameRunning = true;
			genStartingBoard(1);

			System.Drawing.Graphics dc = this.CreateGraphics();
			drawGameState(curGameState, dc);
			dc.Dispose();
		}

		private void Debug_lvl2_Click(object sender, System.EventArgs e)
		{
			debugMsg("debug.loadlevel2 clicked");
			gameRunning = true;
			genStartingBoard(2);

			System.Drawing.Graphics dc = this.CreateGraphics();
			drawGameState(curGameState, dc);
			dc.Dispose();
		}

		private void Debug_lvl3_Click(object sender, System.EventArgs e)
		{
			debugMsg("debug.loadlevel3 clicked");
			gameRunning = true;
			genStartingBoard(3);

			System.Drawing.Graphics dc = this.CreateGraphics();
			drawGameState(curGameState, dc);
			dc.Dispose();
		}

		private void Debug_lvl4_Click(object sender, System.EventArgs e)
		{
			debugMsg("debug.loadlevel4 clicked");
			gameRunning = true;
			genStartingBoard(4);

			System.Drawing.Graphics dc = this.CreateGraphics();
			drawGameState(curGameState, dc);
			dc.Dispose();
		}

		private void Debug_lvl5_Click(object sender, System.EventArgs e)
		{
			debugMsg("debug.loadlevel5 clicked");
			gameRunning = true;
			genStartingBoard(5);

			System.Drawing.Graphics dc = this.CreateGraphics();
			drawGameState(curGameState, dc);
			dc.Dispose();
		}

		private void Debug_lvl6_Click(object sender, System.EventArgs e)
		{
			debugMsg("debug.loadlevel6 clicked");
			gameRunning = true;
			genStartingBoard(6);

			System.Drawing.Graphics dc = this.CreateGraphics();
			drawGameState(curGameState, dc);
			dc.Dispose();
		}

		//key press handler for player movement
		private void KeyPress_Handle(object sender, System.Windows.Forms.KeyEventArgs e)
		{
			//debugMsg("keypress_handle triggered.");

			if(gameRunning)
			{
				//debugMsg(e.KeyCode.ToString());
				switch(e.KeyCode.ToString())
				{
					case "A": //player move left
						takeTurn(moveDirection.MOVE_LEFT);
						break;
					case "S": //player move down
						takeTurn(moveDirection.MOVE_DOWN);
						break;
					case "D": //player move right
						takeTurn(moveDirection.MOVE_RIGHT);
						break;
					case "W": //player move up
						takeTurn(moveDirection.MOVE_UP);
						break;
					case "Q": //player move left + up
						takeTurn(moveDirection.MOVE_UP_LEFT);
						break;
					case "E": //player move right + up
						takeTurn(moveDirection.MOVE_UP_RIGHT);
						break;
					case "Z": //player move left + down
						takeTurn(moveDirection.MOVE_DOWN_LEFT);
						break;
					case "C": //player move right + down
						takeTurn(moveDirection.MOVE_DOWN_RIGHT);
						break;
					case "R": //teleport (not safe)
						takeTurn(moveDirection.TELEPORT);
						break;
					case "T": //teleport (safe)
						takeTurn(moveDirection.TELEPORT_SAFE);
						break;
					case "G": //wait
						takeTurn(moveDirection.WAIT);
						break;
					case "F": //stay
						takeTurn(moveDirection.MOVE_STAY);
						break;
					default:
						//unmapped key
						break;
				}
			}
		}

		//handler for mouse-based player movement
		private void MouseUp_Handle(object sender, System.Windows.Forms.MouseEventArgs e)
		{
			debugMsg("mouseup_handle: button " + e.Button.ToString() + " x " + e.X.ToString() + " y " + e.Y.ToString());
		}

		private void Edit_prefs_Click(object sender, System.EventArgs e)
		{
			debugMsg("edit.controls clicked");

			MessageBox.Show("Robots06 Controls" + Environment.NewLine + Environment.NewLine +
				"Move Left - A" + Environment.NewLine +
				"Move Right - D" + Environment.NewLine +
				"Move Up - W" + Environment.NewLine +
				"Move Down - S" + Environment.NewLine +
				"Move Diagonal Up Left - Q" + Environment.NewLine +
				"Move Diagonal Up Right - E" + Environment.NewLine +
				"Move Diagonal Down Left - Z" + Environment.NewLine +
				"Move Diagonal Down Right - C" + Environment.NewLine + 
				"Stay Put (One Turn) - F" + Environment.NewLine + Environment.NewLine +
				"Random Teleport - R" + Environment.NewLine +
				"Safe Teleport - T" + Environment.NewLine +
				"Wait - G", "Controls", MessageBoxButtons.OK, MessageBoxIcon.Information);

		}

		private void menuItem1_Click(object sender, System.EventArgs e)
		{
			debugMsg("edit.preferences clicked");

			MessageBox.Show("Robots06 Preferences" + Environment.NewLine, "Preferences", MessageBoxButtons.OK, MessageBoxIcon.Information);

		}

	} //public class MainForm
} //namespace Robots06
